.docker_login: &docker-login
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}

.docker_push: &docker-push
    - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}
    - if [[ $CI_COMMIT_REF_SLUG == "main" ]]; then
         docker tag ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG} ${CI_REGISTRY_IMAGE}:latest; fi
    - if [[ $CI_COMMIT_REF_SLUG == "main" ]]; then
         docker push  ${CI_REGISTRY_IMAGE}:latest; fi

.docker_build_dind: &docker-build-dind
    - docker build -t ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG} .

.docker_build:
  stage: build
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_TLS_CERTDIR: ""
  image: docker:20.10.16
  services:
    - docker:20.10.16-dind
  script:
    - *docker-login
    - *docker-build-dind
    - *docker-push
  tags:
    - docker

.docker_release:
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_TLS_CERTDIR: ""
    IMAGE_BRUNCH: 'dev'
  image: docker:20.10.16
  services:
    - docker:20.10.16-dind
  script:
    - *docker-login
    - docker pull ${CI_REGISTRY_IMAGE}:${IMAGE_BRUNCH}
    - docker tag  ${CI_REGISTRY_IMAGE}:${IMAGE_BRUNCH} ${CI_REGISTRY_IMAGE}:latest
    - docker push ${CI_REGISTRY_IMAGE}:latest
  tags:
    - docker
